diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index 3905a51..7982bd9 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,3 +1,9 @@
+2017-09-12  Tom Tromey  <tom@tromey.com>
+
+	* main.c (catch_command_errors): Rename from
+	catch_command_errors_const.
+	(captured_main_1): Update.
+
 2017-09-12  Simon Marchi  <simon.marchi@ericsson.com>
 
 	* probe.h (probe_ops_cp): Remove typedef.
diff --git a/gdb/main.c b/gdb/main.c
index a0646ed..fe80511 100644
--- a/gdb/main.c
+++ b/gdb/main.c
@@ -340,8 +340,7 @@ captured_command_loop (void *data)
   return 1;
 }
 
-/* Handle command errors thrown from within
-   catch_command_errors/catch_command_errors_const.  */
+/* Handle command errors thrown from within catch_command_errors.  */
 
 static int
 handle_command_errors (struct gdb_exception e)
@@ -386,15 +385,16 @@ catch_command_errors (catch_command_errors_ftype *command,
   return 1;
 }
 
-/* Type of the command callback passed to catch_command_errors_const.  */
+/* Type of the command callback passed to the const
+   catch_command_errors.  */
 
 typedef void (catch_command_errors_const_ftype) (const char *, int);
 
-/* Like catch_command_errors, but works with const command and args.  */
+/* Const-correct catch_command_errors.  */
 
 static int
-catch_command_errors_const (catch_command_errors_const_ftype *command,
-			    const char *arg, int from_tty)
+catch_command_errors (catch_command_errors_const_ftype command,
+		      const char *arg, int from_tty)
 {
   TRY
     {
@@ -982,7 +982,7 @@ captured_main_1 (struct captured_main_args *context)
      processed; it sets global parameters, which are independent of
      what file you are debugging or what directory you are in.  */
   if (system_gdbinit && !inhibit_gdbinit)
-    catch_command_errors_const (source_script, system_gdbinit, 0);
+    catch_command_errors (source_script, system_gdbinit, 0);
 
   /* Read and execute $HOME/.gdbinit file, if it exists.  This is done
      *before* all the command line arguments are processed; it sets
@@ -990,7 +990,7 @@ captured_main_1 (struct captured_main_args *context)
      debugging or what directory you are in.  */
 
   if (home_gdbinit && !inhibit_gdbinit && !inhibit_home_gdbinit)
-    catch_command_errors_const (source_script, home_gdbinit, 0);
+    catch_command_errors (source_script, home_gdbinit, 0);
 
   /* Process '-ix' and '-iex' options early.  */
   for (i = 0; i < cmdarg_vec.size (); i++)
@@ -1000,8 +1000,8 @@ captured_main_1 (struct captured_main_args *context)
       switch (cmdarg_p.type)
 	{
 	case CMDARG_INIT_FILE:
-	  catch_command_errors_const (source_script, cmdarg_p.string,
-				      !batch_flag);
+	  catch_command_errors (source_script, cmdarg_p.string,
+				!batch_flag);
 	  break;
 	case CMDARG_INIT_COMMAND:
 	  catch_command_errors (execute_command, cmdarg_p.string,
@@ -1032,19 +1032,19 @@ captured_main_1 (struct captured_main_args *context)
       /* The exec file and the symbol-file are the same.  If we can't
          open it, better only print one error message.
          catch_command_errors returns non-zero on success!  */
-      if (catch_command_errors_const (exec_file_attach, execarg,
-				      !batch_flag))
-	catch_command_errors_const (symbol_file_add_main_adapter, symarg,
-				    !batch_flag);
+      if (catch_command_errors (exec_file_attach, execarg,
+				!batch_flag))
+	catch_command_errors (symbol_file_add_main_adapter, symarg,
+			      !batch_flag);
     }
   else
     {
       if (execarg != NULL)
-	catch_command_errors_const (exec_file_attach, execarg,
-				    !batch_flag);
+	catch_command_errors (exec_file_attach, execarg,
+			      !batch_flag);
       if (symarg != NULL)
-	catch_command_errors_const (symbol_file_add_main_adapter, symarg,
-				    !batch_flag);
+	catch_command_errors (symbol_file_add_main_adapter, symarg,
+			      !batch_flag);
     }
 
   if (corearg && pidarg)
@@ -1094,7 +1094,7 @@ captured_main_1 (struct captured_main_args *context)
 	{
 	  auto_load_local_gdbinit_loaded = 1;
 
-	  catch_command_errors_const (source_script, local_gdbinit, 0);
+	  catch_command_errors (source_script, local_gdbinit, 0);
 	}
     }
 
@@ -1114,8 +1114,8 @@ captured_main_1 (struct captured_main_args *context)
       switch (cmdarg_p.type)
 	{
 	case CMDARG_FILE:
-	  catch_command_errors_const (source_script, cmdarg_p.string,
-				      !batch_flag);
+	  catch_command_errors (source_script, cmdarg_p.string,
+				!batch_flag);
 	  break;
 	case CMDARG_COMMAND:
 	  catch_command_errors (execute_command, cmdarg_p.string,