diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index 74928c0113..f69bd06aec 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,5 +1,13 @@
 2017-09-14  John Baldwin  <jhb@FreeBSD.org>
 
+	* Makefile.in (ALLDEPFILES): Add arm-fbsd-nat.c.
+	* NEWS: Mention new FreeBSD/arm native configuration.
+	* configure.host: Add arm*-*-freebsd*.
+	* configure.nat: Likewise.
+	* arm-fbsd-nat.c: New file.
+
+2017-09-14  John Baldwin  <jhb@FreeBSD.org>
+
 	* Makefile.in (ALL_TARGET_OBS): Add arm-fbsd-tdep.o.
 	(ALLDEPFILES): Add arm-fbsd-tdep.c.
 	* NEWS: Mention new FreeBSD/arm target.
diff --git a/gdb/Makefile.in b/gdb/Makefile.in
index 3468e34b6e..52f1c5cd19 100644
--- a/gdb/Makefile.in
+++ b/gdb/Makefile.in
@@ -2530,6 +2530,7 @@ ALLDEPFILES = \
 	arc-tdep.c \
 	arm.c \
 	arm-bsd-tdep.c \
+	arm-fbsd-nat.c \
 	arm-fbsd-tdep.c \
 	arm-get-next-pcs.c \
 	arm-linux.c \
diff --git a/gdb/NEWS b/gdb/NEWS
index f33b7ac49f..c54a458530 100644
--- a/gdb/NEWS
+++ b/gdb/NEWS
@@ -101,6 +101,7 @@ show debug separate-debug-file
 * New native configurations
 
 FreeBSD/aarch64			aarch64*-*-freebsd*
+FreeBSD/arm			arm*-*-freebsd*
 
 * New targets
 
diff --git a/gdb/arm-fbsd-nat.c b/gdb/arm-fbsd-nat.c
new file mode 100644
index 0000000000..b1c5c360f8
--- /dev/null
+++ b/gdb/arm-fbsd-nat.c
@@ -0,0 +1,151 @@
+/* Native-dependent code for FreeBSD/arm.
+
+   Copyright (C) 2017 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+#include "defs.h"
+#include "target.h"
+
+#include <sys/types.h>
+#include <sys/ptrace.h>
+#include <machine/reg.h>
+
+#include "fbsd-nat.h"
+#include "arm-tdep.h"
+#include "arm-fbsd-tdep.h"
+#include "inf-ptrace.h"
+
+/* Determine if PT_GETREGS fetches REGNUM.  */
+
+static bool
+getregs_supplies (struct gdbarch *gdbarch, int regnum)
+{
+  return ((regnum >= ARM_A1_REGNUM && regnum <= ARM_PC_REGNUM)
+	  || regnum == ARM_PS_REGNUM);
+}
+
+#ifdef PT_GETVFPREGS
+/* Determine if PT_GETVFPREGS fetches REGNUM.  */
+
+static bool
+getvfpregs_supplies (struct gdbarch *gdbarch, int regnum)
+{
+  return ((regnum >= ARM_D0_REGNUM && regnum <= ARM_D31_REGNUM)
+	  || regnum == ARM_FPSCR_REGNUM);
+}
+#endif
+
+/* Fetch register REGNUM from the inferior.  If REGNUM is -1, do this
+   for all registers.  */
+
+static void
+arm_fbsd_fetch_inferior_registers (struct target_ops *ops,
+				    struct regcache *regcache, int regnum)
+{
+  pid_t pid = get_ptrace_pid (regcache_get_ptid (regcache));
+
+  struct gdbarch *gdbarch = get_regcache_arch (regcache);
+  if (regnum == -1 || getregs_supplies (gdbarch, regnum))
+    {
+      struct reg regs;
+
+      if (ptrace (PT_GETREGS, pid, (PTRACE_TYPE_ARG3) &regs, 0) == -1)
+	perror_with_name (_("Couldn't get registers"));
+
+      regcache->supply_regset (&arm_fbsd_gregset, regnum, &regs,
+			       sizeof (regs));
+    }
+
+#ifdef PT_GETVFPREGS
+  if (regnum == -1 || getvfpregs_supplies (gdbarch, regnum))
+    {
+      struct vfpreg vfpregs;
+
+      if (ptrace (PT_GETVFPREGS, pid, (PTRACE_TYPE_ARG3) &vfpregs, 0) == -1)
+	perror_with_name (_("Couldn't get floating point status"));
+
+      regcache->supply_regset (&arm_fbsd_vfpregset, regnum, &vfpregs,
+			       sizeof (vfpregs));
+    }
+#endif
+}
+
+/* Store register REGNUM back into the inferior.  If REGNUM is -1, do
+   this for all registers.  */
+
+static void
+arm_fbsd_store_inferior_registers (struct target_ops *ops,
+				    struct regcache *regcache, int regnum)
+{
+  pid_t pid = get_ptrace_pid (regcache_get_ptid (regcache));
+
+  struct gdbarch *gdbarch = get_regcache_arch (regcache);
+  if (regnum == -1 || getregs_supplies (gdbarch, regnum))
+    {
+      struct reg regs;
+
+      if (ptrace (PT_GETREGS, pid, (PTRACE_TYPE_ARG3) &regs, 0) == -1)
+	perror_with_name (_("Couldn't get registers"));
+
+      regcache->collect_regset (&arm_fbsd_gregset, regnum, &regs,
+			       sizeof (regs));
+
+      if (ptrace (PT_SETREGS, pid, (PTRACE_TYPE_ARG3) &regs, 0) == -1)
+	perror_with_name (_("Couldn't write registers"));
+    }
+
+#ifdef PT_GETVFPREGS
+  if (regnum == -1 || getvfpregs_supplies (gdbarch, regnum))
+    {
+      struct vfpreg vfpregs;
+
+      if (ptrace (PT_GETVFPREGS, pid, (PTRACE_TYPE_ARG3) &vfpregs, 0) == -1)
+	perror_with_name (_("Couldn't get floating point status"));
+
+      regcache->collect_regset (&arm_fbsd_vfpregset, regnum, &vfpregs,
+				sizeof (vfpregs));
+
+      if (ptrace (PT_SETVFPREGS, pid, (PTRACE_TYPE_ARG3) &vfpregs, 0) == -1)
+	perror_with_name (_("Couldn't write floating point status"));
+    }
+#endif
+}
+
+/* Implement the to_read_description method.  */
+
+static const struct target_desc *
+arm_fbsd_read_description (struct target_ops *ops)
+{
+  const struct target_desc *desc;
+
+  desc = arm_fbsd_read_description_auxv (ops);
+  if (desc == NULL)
+    desc = ops->beneath->to_read_description (ops->beneath);
+  return desc;
+}
+
+void
+_initialize_arm_fbsd_nat (void)
+{
+  struct target_ops *t;
+
+  t = inf_ptrace_target ();
+  t->to_fetch_registers = arm_fbsd_fetch_inferior_registers;
+  t->to_store_registers = arm_fbsd_store_inferior_registers;
+  t->to_read_description = arm_fbsd_read_description;
+  fbsd_nat_add_target (t);
+}
diff --git a/gdb/configure.host b/gdb/configure.host
index 304675f137..ee53f25e9e 100644
--- a/gdb/configure.host
+++ b/gdb/configure.host
@@ -91,6 +91,7 @@ alpha*-*-netbsd* | alpha*-*-knetbsd*-gnu)
 			gdb_host=nbsd ;;
 alpha*-*-openbsd*)	gdb_host=nbsd ;;
 
+arm*-*-freebsd*)	gdb_host=fbsd ;;
 arm*-*-linux*)		gdb_host=linux ;;
 arm*-*-netbsdelf* | arm*-*-knetbsd*-gnu)
 			gdb_host=nbsdelf ;;
diff --git a/gdb/configure.nat b/gdb/configure.nat
index a318b4a5a9..c08079b7ea 100644
--- a/gdb/configure.nat
+++ b/gdb/configure.nat
@@ -150,6 +150,11 @@ case ${gdb_host} in
 		NATDEPFILES="${NATDEPFILES} aarch64-fbsd-nat.o"
 		LOADLIBES=
 		;;
+	    arm)
+		# Host: FreeBSD/arm
+		NATDEPFILES="${NATDEPFILES} arm-fbsd-nat.o"
+		LOADLIBES=
+		;;
 	    i386)
 		# Host: FreeBSD/i386
 		NATDEPFILES="${NATDEPFILES} x86-nat.o x86-dregs.o \